package com.cursedcauldron.wildbackport.common.blocks;

import java.util.Random;

import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.BonemealableBlock;
import net.minecraft.world.level.block.LeavesBlock;
import net.minecraft.world.level.block.state.BlockState;

//<>

public class MangroveLeavesBlock extends LeavesBlock implements BonemealableBlock {
    public MangroveLeavesBlock(Properties properties) {
        super(properties);
    }

    @Override
    public boolean isValidBonemealTarget(
        BlockGetter block, BlockPos pos, BlockState state, boolean flag
    ) {
        return block.getBlockState(pos.below()).isAir();
    }

    @Override
    public boolean
    isBonemealSuccess(Level level, Random random, BlockPos pos, BlockState state) {
        return true;
    }

    @Override
    public void
    performBonemeal(ServerLevel level, Random random, BlockPos pos, BlockState state) {
        level.setBlock(pos.below(), MangrovePropaguleBlock.createPropagule(), 2);
    }
}